'use strict';

var Monitor = function(){
    var vars = {
            $monitor : '',

            monitorInterval: {},
            dbg: true
        },

    // _____  ________      _______ _____ ______   _    _ _____   _____
    // |  __ \|  ____\ \    / /_   _/ ____|  ____| | |  | |  __ \ / ____|
    // | |  | | |__   \ \  / /  | || |    | |__    | |  | | |__) | (___
    // | |  | |  __|   \ \/ /   | || |    |  __|   | |  | |  ___/ \___ \
    // | |__| | |____   \  /   _| || |____| |____  | |__| | |     ____) |
    // |_____/|______|   \/   |_____\_____|______|  \____/|_|    |_____/

        setUPSStatus = function setStatus(status){
                var prefix = "status-",
                    classList = [],
                    newState;

            },

        updateUPSVariables = function(v){

            vars.$monitor.find(".load1").html(v.load1);
            vars.$monitor.find(".load2").html(v.load2);
            vars.$monitor.find(".load3").html(v.load3);

            //battery section
            vars.$monitor.find(".autonomy").html( minToHHMM(v.authonomy) );
            vars.$monitor.find(".batcap").html( v.batcap );
        },

        updateAlarmList = function updateAlarmList(v){

            var $widgetWrapperAlarm = $(".js-alarms-monitor"),
                alarmTpls = {
                    'row' : [
                        "<div class='alarm-monitor-item col-md-3'><span class='type'>---</span></div>",
                    ].join(" ")
                },
                i,
                tpl,
                alarms = v.alarms,
                status_color = v.system_status.status_color;

            //checking alarms
            $widgetWrapperAlarm.empty();

            if(alarms && alarms.length > 0){

                for(i=0; i<alarms.length; i++){

                    if(alarms[i] !== undefined){

                        var alarmType;

                        alarmType = 'row';

                        tpl = $(alarmTpls[alarmType]).clone();

                        var ref = tpl.find(".type");
                        switch (alarms[i].category){
                            default:
                            case 0:
                                ref.addClass("commlost");
                                if( i == 0) {
                                    status_color = "#777777";
                                }
                                break;
                            case 1:
                                ref.addClass("critical");
                                if( i == 0) {
                                    status_color = "#cc0000";
                                }
                                break;
                            case 2:
                                ref.addClass("major");
                                if( i == 0) {
                                    status_color = "#e94f0f";
                                }
                                break;
                            case 3:
                                ref.addClass("minor");
                                if( i == 0) {
                                    status_color = "#f0ad4e";
                                }
                                break;
                            case 4:
                                ref.addClass("info");
                                break;
                        }
                        ref.text(alarms[i].alarm);

                        tpl.appendTo($widgetWrapperAlarm);
                    }
                }
            }

            // ora posso colorare e scrive il system status
            vars.$monitor.find(".systemStatus")
                .html( nullReplace( v.system_status.status ) )
                .css( "color", status_color );

        },

        clearIntervals = function clearIntervals(){
            window.clearInterval(vars.monitorInterval);
        },

    // ---- TEST FUNCTIONS ----

        showcase = function showcase(status){
            Main.clearIntervals();

            if(status === undefined){
                vars.monitorInterval = window.setInterval(function(){
                    setUPSStatus(Math.floor(Math.random()*6));
                },3000);
            }else{
                setUPSStatus(status);
            }
        },
    // ----- Init -----

        init = function init() {

            if ( !($("#monitor-UPS").hasClass("hidden"))) {
                vars.$monitor = $("#monitor-UPS");
            }
            else if (!$("#monitor-unknown").hasClass("hidden")) {
                vars.$monitor = $("#monitor-unknown");
            }

        };

    return {
        init: function(){ init(); },
        showcase: showcase,
        setUPSStatus: setUPSStatus,
        updateUPSVariables: updateUPSVariables,
        updateAlarmList: updateAlarmList,

        clearIntervals: clearIntervals
    }
}();
